/*
 * dsp.cpp
 *
 *  Created on: 29 mar 2023
 *      Author: Tomek
 */
/*****************************************************************************************************************************************/
#include "app.h"
#include "dsp.hpp"
//#include "gui.h"


#define PomiarAmplitudy(n,x)\
	static float n##BA = 0;\
	static float n##C1 = 0;\
	n##C1 += (((x<0) ? -x :x)-n##C1)*T_PA;\
	n##BA += (n##C1-n##BA)*T_PA;


T_Poziomy Poz = {0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5};


#define Filtr(f,q,x,y){\
		static float uc = 0;\
		static float IL = 0;\
		uc += IL * (float)((float)2 * STALA_PI / FP * (float)(q) * (float)(f));\
		IL += (x - uc - IL) * (float)((float)2 * STALA_PI / FP * (float)(f) / (float)(q));\
		y = IL;}


void __attribute__((section("RamFunction"))) PrzetwarzanieGlowne()
{
	volatile register float kl = 0,kp = 0,wy,wl,wp;
	wl = (float)WartoscWE_L/(float)0x7FFF;
	wp = (float)WartoscWE_P/(float)0x7FFF;

	Filtr(21.5,1,wl,wy);
	kl+=wy*Poz.A20L;
	Filtr(21,1,wp,wy);
	kp+=wy*Poz.A20P;

	Filtr(46.4,1,wl,wy);
	kl+=wy*Poz.A50L;
	Filtr(46.4,1,wp,wy);
	kp+=wy*Poz.A50P;

	Filtr(100,1,wl,wy);
	kl+=wy*Poz.A100L;
	Filtr(100,1,wp,wy);
	kp+=wy*Poz.A100P;

	Filtr(215,1,wl,wy);
	kl+=wy*Poz.A200L;
	Filtr(215,1,wp,wy);
	kp+=wy*Poz.A200P;

	Filtr(464,1,wl,wy);
	kl+=wy*Poz.A50L;
	Filtr(464,1,wp,wy);
	kp+=wy*Poz.A500P;

	Filtr(1000,1,wl,wy);
	kl+=wy*Poz.A1KL;
	Filtr(1000,1,wp,wy);
	kp+=wy*Poz.A1KP;

	Filtr(2150,1,wl,wy);
	kl+=wy*Poz.A2KL;
	Filtr(2150,1,wp,wy);
	kp+=wy*Poz.A2KP;

	Filtr(4640,1,wl,wy);
	kl+=wy*Poz.A5KL;
	Filtr(4640,1,wp,wy);
	kp+=wy*Poz.A5KP;

	Filtr(10000,1.5,wl,wy);
	kl+=wy*Poz.A10KL;
	Filtr(10000,1.5,wp,wy);
	kp+=wy*Poz.A10KP;

	WartoscWY_L = (int16_t)(kl*(float)0x7FFF);
    WartoscWY_P = (int16_t)(kp*(float)0x7FFF);
}
