/*
 * dsp.h
 *
 *  Created on: 29 mar 2023
 *      Author: Tomek
 */

#ifndef DSP_H_
#define DSP_H_


#include "stdint.h"
#include "string.h"

#define FP			(float)48000
#define STALA_PI	(float)3.141592

enum T_NazwyKan
{
	KL_20,
	KL_50,
	KL_100,
	KL_200,
	KL_500,
	KL_1K,
	KL_2K,
	KL_5K,
	KL_10K,
	KP_20,
	KP_50,
	KP_100,
	KP_200,
	KP_500,
	KP_1K,
	KP_2K,
	KP_5K,
	KP_10K
};



union T_Poziomy{
	struct {
		float A20L, A50L, A100L, A200L, A500L, A1KL, A2KL, A5KL, A10KL, A20P, A50P, A100P, A200P, A500P, A1KP, A2KP, A5KP, A10KP;
	};
	float Tab[18];
};

extern union T_Poziomy Poz;

void PrzetwarzanieGlowne();

#endif /* DSP_H_ */
;
