/*
 * LCD.cpp
 *
 *  Created on: 20 sie 2021
 *      Author: Tomek
 */


//#include "LCD.h"
#include "grafika.h"
#include "stdlib.h"
#include "string.h"

#define WSTAW_PUNKT(o,xp,yp){\
	volatile register int WP##x = (xp), WP##y = (yp);\
	if(WP##x>=0 && WP##y>=0 && WP##x<o->RozmiarX && WP##y<o->RozmiarY)\
		LCDImp::Ekran[WP##x][WP##y/8] |= (1<<WP##y%8);}




void Grafika::RysujProstokat(int x1,int y1,int x2,int y2)
{

	if(x1<RozmiarX && y1<RozmiarY && x2>=0 && y2>=0 && x2>=x1 && y2>=y1)
	{

		if(x1<0) x1 = 0;
		if(y1<0) y1 = 0;
		if(x2>=RozmiarX) x2 = RozmiarX-1;
		if(y2>=RozmiarY) y2 = RozmiarY-1;

		int y;
		for(y=y1;y<=y2;++y)
			RysujLinie(x1,y,x2,y);
	}
}


void Grafika::RysujLinie(int x1,int y1,int x2,int y2)
{
	int dx = x2-x1, dy = y2-y1;
	int sx = abs(dx), sy = abs(dy);
	int x = x1, y = y1;



	for(;(dy<0 ? y>=y2 : y<=y2) && (dx<0 ? x>=x2 : x <=x2);)
	{
		WSTAW_PUNKT(this,x,y);
		if(sx>sy)
		{
			sy += abs(dy);

			if(dx<0) --x;
			else ++x;

		} else if(sy>sx)
		{
			sx += abs(dx);

			if(dy<0)--y;
			else ++y;

		} else
		{
			sx += abs(dx);

			if(dy<0)--y;
			else ++y;

			sy += abs(dy);

			if(dx<0) --x;
			else ++x;
		}
	}
}


void Grafika::AktualizujEkran()
{
	LCDImp::Potwierdz();
}

void Grafika::Wyczysc()
{
	memset(LCDImp::Ekran,0,sizeof(LCDImp::Ekran));

}

void Grafika::RysujOkrag(int x0,int y0,int r)
{
	int sx = r, sy = 0;
	int x = r, y = 0;

	for(;y<=r || x >=0;)
	{
		WSTAW_PUNKT(this,x+x0,y+y0);
		WSTAW_PUNKT(this,-x+x0,y+y0);
		WSTAW_PUNKT(this,x+x0,-y+y0);
		WSTAW_PUNKT(this,-x+x0,-y+y0);
		if(sx>sy)
		{
			sy += y;
			++y;
		} else if(sy>sx)
		{
			sx += x;
			--x;
		} else
		{
			sx += x;
			sy += y;
			--x;
			++y;
		}
	}
}


void Grafika::RysujKolo(int x0,int y0,int r)
{
	int sx = 0, sy = 0;
	int x = r, y = 0;

	for(;y<=r || x >=0;)
	{
		RysujLinie(-x+x0,-y+y0, x+x0, -y+y0);
		RysujLinie(-x+x0,y+y0, x+x0, y+y0);

		if(sx>sy)
		{
			sy += y;
			++y;
		} else if(sy>sx)
		{
			sx += x;
			--x;
		} else
		{
			sx += x;
			sy += y;
			--x;
			++y;
		}
	}
}

void Grafika::RysujPunkt(int x, int y)
{
	WSTAW_PUNKT(this,x,y);
}


void Grafika::RysujTekst(int x0,int y0,const char *t, bool neg, bool pion)
{

	int m,x,y,i;
	for (i=0;t[i];++i)
	{
		int ind = t[i]-' ';
		if(!pion)
		{
			for(y=0;y<FONT_SZ;++y)
				for(x=0,m=0x80;x<FONT_WYS;m>>=1,++x)
					if((!!(TablicaZnakow[ind][y]&m))^neg)
						WSTAW_PUNKT(this,x+x0+i*FONT_SZ,y+y0);
		} else
		{
			for(x=0;x<FONT_SZ;++x)
				for(y=0,m=0x80;y<FONT_WYS;m>>=1,++y)
					if((!!(TablicaZnakow[ind][FONT_WYS-x-1]&m))^neg)
						WSTAW_PUNKT(this,x+x0,y+y0+i*FONT_SZ);

		}
	}

}


