/*
 * lcd.cpp
 *
 *  Created on: 9 cze 2023
 *      Author: Tomek
 */
#include "LCD.h"
#include "fsl_spi.h"
#include "peripherals.h"
#include "pin_mux.h"
#include "fsl_gpio.h"
#include "fsl_ctimer.h"


BYTE LCDImp::Ekran[I_KOLUMN][I_LINII/8];

void CzekajDane()
{
    CTIMER_Reset(CTIMER1_PERIPHERAL);
	CTIMER1_PERIPHERAL->EMR &= ~(uint32_t)1;
	CTIMER_StartTimer(CTIMER1_PERIPHERAL);
    while(!(CTIMER1_PERIPHERAL->EMR&1));

}

void CzekajKom()
{
	int i;
	for(i=0;i<10;++i)	CzekajDane();
}

uint32_t fifostat;
uint32_t cfg;
bool stat1;
bool stat2;


void LCDImp::Wyslij1(BYTE x)
{
	union {
		uint16_t w;
		struct {BYTE d,k;};
	} zp;

	zp.k = 0b01000000;
	zp.d = x;

	SPI_WriteData(FLEXCOMM8_PERIPHERAL, zp.w, kSPI_FrameAssert);
	while(!(FLEXCOMM8_PERIPHERAL->FIFOSTAT&SPI_FIFOSTAT_TXEMPTY_MASK ));
	CzekajDane();

}


void LCDImp::Wyslij2(BYTE x)
{
	union {
		uint16_t w;
		struct {BYTE d,k;};
	} zp;

	zp.k = 0b11000000;
	zp.d = x;


	SPI_WriteData(FLEXCOMM8_PERIPHERAL, zp.w, kSPI_FrameAssert);
	while(!(FLEXCOMM8_PERIPHERAL->FIFOSTAT&SPI_FIFOSTAT_TXEMPTY_MASK ));
	CzekajDane();

}


void LCDImp::WyslijKom1(BYTE x)
{
	union {
		uint16_t w;
		struct {BYTE d,k;};
	} zp;

	zp.k = 0b00000000;
	zp.d = x;


	SPI_WriteData(FLEXCOMM8_PERIPHERAL, zp.w, kSPI_FrameAssert);
	while(!(FLEXCOMM8_PERIPHERAL->FIFOSTAT&SPI_FIFOSTAT_TXEMPTY_MASK ));
	CzekajKom();
}

void LCDImp::WyslijKom2(BYTE x)
{
	union {
		uint16_t w;
		struct {BYTE d,k;};
	} zp;

	zp.k = 0b10000000;
	zp.d = x;


	SPI_WriteData(FLEXCOMM8_PERIPHERAL, zp.w, kSPI_FrameAssert);
	while(!(FLEXCOMM8_PERIPHERAL->FIFOSTAT&SPI_FIFOSTAT_TXEMPTY_MASK ));
	CzekajKom();
}


void LCDImp::Inicjuj()
{
	GPIO_PinWrite(BOARD_INITDEBUG_UARTPINS_LCD_RESET_GPIO, BOARD_INITDEBUG_UARTPINS_LCD_RESET_PORT,
			BOARD_INITDEBUG_UARTPINS_LCD_RESET_PIN, 0);
	CzekajKom();
	GPIO_PinWrite(BOARD_INITDEBUG_UARTPINS_LCD_RESET_GPIO, BOARD_INITDEBUG_UARTPINS_LCD_RESET_PORT,
			BOARD_INITDEBUG_UARTPINS_LCD_RESET_PIN, 1);
	CzekajKom();
	FLEXCOMM8_PERIPHERAL->FIFOCFG &= ~SPI_FIFOCFG_ENABLERX_MASK;

	memset((void*)Ekran,0x33,sizeof(Ekran));
	//CTIMER_StartTimer(CTIMER1_PERIPHERAL);
	WyslijKom1(LCDImp::DISPLAY_ON);
	WyslijKom2(LCDImp::DISPLAY_ON);


	Potwierdz();

}

void LCDImp::Potwierdz()
{
	int i,j;

	WyslijKom1(LCDImp::SET_X);
	WyslijKom1(LCDImp::SET_Y);
	WyslijKom1(LCDImp::SET_Z);
	WyslijKom2(LCDImp::SET_X);
	WyslijKom2(LCDImp::SET_Y);
	WyslijKom2(LCDImp::SET_Z);

	for(j=0;j<I_LINII/8;++j)
	{
		WyslijKom1(LCDImp::SET_X+j);
		for(i=0;i<I_KOLUMN/2;++i)
			Wyslij1(Ekran[i][j]);
	}

	for(j=0;j<I_LINII/8;++j)
	{
		WyslijKom2(LCDImp::SET_X+j);
		for(i=0;i<I_KOLUMN/2;++i)
			Wyslij2(Ekran[i+64][j]);
	}

}



