
#include "app.h"
#include "pin_mux.h"
#include "fsl_iocon.h"
#include "fsl_gpio.h"
#include "peripherals.h"
#include "dsp.hpp"

#define PRZELACZNIK1 (GPIO_PinRead(BOARD_INITBUTTONSPINS_S3_GPIO, BOARD_INITBUTTONSPINS_S3_PORT, BOARD_INITBUTTONSPINS_S3_PIN)&&GPIO_PinRead(BOARD_INITDEBUG_UARTPINS_S2_GPIO, BOARD_INITDEBUG_UARTPINS_S2_PORT, BOARD_INITDEBUG_UARTPINS_S2_PIN))
#define PRZELACZNIK2 (GPIO_PinRead(BOARD_INITBUTTONSPINS_S2_GPIO, BOARD_INITBUTTONSPINS_S2_PORT, BOARD_INITBUTTONSPINS_S2_PIN)&&GPIO_PinRead(BOARD_INITDEBUG_UARTPINS_S1_GPIO, BOARD_INITDEBUG_UARTPINS_S1_PORT, BOARD_INITDEBUG_UARTPINS_S1_PIN))
#define IMP_A GPIO_PinRead(BOARD_INITDEBUG_UARTPINS_ENKODER2_GPIO, BOARD_INITDEBUG_UARTPINS_ENKODER2_PORT, BOARD_INITDEBUG_UARTPINS_ENKODER2_PIN)
#define IMP_B GPIO_PinRead(BOARD_INITDEBUG_UARTPINS_ENKODER3_GPIO, BOARD_INITDEBUG_UARTPINS_ENKODER3_PORT, BOARD_INITDEBUG_UARTPINS_ENKODER3_PIN)
#define IMP_P GPIO_PinRead(BOARD_INITBUTTONSPINS_S1_GPIO, BOARD_INITBUTTONSPINS_S1_PORT, BOARD_INITBUTTONSPINS_S1_PIN)

void (*Przelacznik1)() = NULL;
void (*Przelacznik2)() = NULL;
void (*EnkoderWlacznik)() = NULL;
void (*ObslugaEnkodera)(bool) = NULL;
void (*PPrzerwanie)() = NULL;



void ObslugaImpulsatora()
{
	static bool poprzedni_l = 1, poprzedni_p = 1, ostatni_sw = true;

	if(poprzedni_p && !IMP_B)
	{
		if(IMP_A && poprzedni_l == 1)
		{
			if(ObslugaEnkodera)
				ObslugaEnkodera(false);
		}
	}
	if(poprzedni_l && !IMP_A)
	{
		if(IMP_B && poprzedni_p == 1)
		{
			if(ObslugaEnkodera)
				ObslugaEnkodera(true);
		}
	}
	poprzedni_l = IMP_A;
	poprzedni_p = IMP_B;

	if( !IMP_P && ostatni_sw==1)
	{
		if(EnkoderWlacznik)
		EnkoderWlacznik();
	}

	ostatni_sw = IMP_P;
}


void ObslugaT2(uint32_t flags)
{
	static bool ostatni_p1 = 1, ostatni_p2 = 1;
	ObslugaImpulsatora();

	if( !PRZELACZNIK1 && ostatni_p1==1)
	{
		if(Przelacznik1)
			Przelacznik1();
	}
	if(!PRZELACZNIK2 && ostatni_p2==1)
	{
		if(Przelacznik2)
			Przelacznik2();
	}

	ostatni_p1 = PRZELACZNIK1;
	ostatni_p2 = PRZELACZNIK2;

	if(PPrzerwanie)
		PPrzerwanie();
}

